## amgcl 1.4.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Build type")
    message(STATUS "No build type selected, default to ${CMAKE_BUILD_TYPE}")
endif()

project(AMGCL)

if (NOT (CMAKE_VERSION LESS 3.3))
    cmake_policy(SET CMP0058 OLD)
endif()

set(AMGCL_MASTER_PROJECT OFF)
if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    set(AMGCL_MASTER_PROJECT ON)
endif()

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
if (CMAKE_VERSION VERSION_LESS "3.1.0")
    set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/opencl)
endif()

#----------------------------------------------------------------------------
# Find Boost
#----------------------------------------------------------------------------
option(Boost_USE_STATIC_LIBS "Use static versions of Boost libraries" OFF)
if (WIN32)
    set(Boost_USE_STATIC_LIBS ON)
endif ()

find_package(Boost REQUIRED COMPONENTS
    program_options
    serialization
    unit_test_framework
    )

#----------------------------------------------------------------------------
# Builtin backend
#----------------------------------------------------------------------------
add_library(amgcl INTERFACE)
add_library(amgcl::amgcl ALIAS amgcl)

target_compile_features(amgcl INTERFACE
    cxx_auto_type
    cxx_range_for
    cxx_rvalue_references
    cxx_right_angle_brackets
    cxx_static_assert
)

target_include_directories(amgcl SYSTEM INTERFACE
    ${Boost_INCLUDE_DIRS}
    )

target_include_directories(amgcl INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>
    )

find_package(OpenMP)
if (OPENMP_FOUND)
    target_compile_options(amgcl INTERFACE ${OpenMP_CXX_FLAGS})
    target_link_libraries(amgcl INTERFACE
        $<$<CXX_COMPILER_ID:GNU>:${OpenMP_CXX_FLAGS}>
        $<$<CXX_COMPILER_ID:Clang>:${OpenMP_CXX_FLAGS}>
        $<$<CXX_COMPILER_ID:Intel>:${OpenMP_CXX_FLAGS}>
        )
endif ()

#----------------------------------------------------------------------------
# Common compile options and definitions
#----------------------------------------------------------------------------
target_compile_options(amgcl INTERFACE
    # Compiler is GNU (g++):
    $<$<CXX_COMPILER_ID:GNU>:$<BUILD_INTERFACE:-Wall;-Wextra;-Wpedantic>>
    # Compiler is Clang:
    $<$<CXX_COMPILER_ID:Clang>:$<BUILD_INTERFACE:-Wall;-Wextra;-Wpedantic;-Wno-c99-extensions>>
    # Compiler is MSVC:
    $<$<CXX_COMPILER_ID:MSVC>:/bigobj>
    $<$<CXX_COMPILER_ID:MSVC>:/wd4715>
    )

target_compile_definitions(amgcl INTERFACE
    # Compiler is MSVC:
    $<$<CXX_COMPILER_ID:MSVC>:NOMINMAX>
    $<$<CXX_COMPILER_ID:MSVC>:_USE_MATH_DEFINES>
    $<$<CXX_COMPILER_ID:MSVC>:_VARIADIC_MAX=10>
    $<$<CXX_COMPILER_ID:MSVC>:_SCL_SECURE_NO_WARNINGS>
    )

#----------------------------------------------------------------------------
# Eigen backend
#----------------------------------------------------------------------------
find_path(EIGEN_INCLUDE Eigen/SparseCore PATH_SUFFIXES eigen3)
if (EIGEN_INCLUDE)
    add_library(eigen_target INTERFACE)
    target_include_directories(eigen_target INTERFACE ${EIGEN_INCLUDE})
    target_compile_options(eigen_target INTERFACE
        $<$<CXX_COMPILER_ID:GNU>:-Wno-int-in-bool-context>
        $<$<CXX_COMPILER_ID:GNU>:-Wno-maybe-uninitialized>
        $<$<CXX_COMPILER_ID:GNU>:-Wno-deprecated-copy>
        $<$<CXX_COMPILER_ID:Clang>:-Wno-deprecated-copy>
        $<$<CXX_COMPILER_ID:Clang>:-Wno-c++11-long-long>
        )
    target_compile_definitions(eigen_target INTERFACE AMGCL_HAVE_EIGEN)
endif()

#----------------------------------------------------------------------------
# Find Blaze
#----------------------------------------------------------------------------
find_package(blaze QUIET)
if (blaze_FOUND)
    add_library(blaze_target INTERFACE)
    target_link_libraries(blaze_target INTERFACE blaze::blaze)
endif()

#----------------------------------------------------------------------------
# Find VexCL
#----------------------------------------------------------------------------
find_package(VexCL QUIET)

#----------------------------------------------------------------------------
# Find ViennaCL
#----------------------------------------------------------------------------
find_path(VIENNACL_INCLUDE viennacl/forwards.h)
if (VIENNACL_INCLUDE)
    add_library(viennacl_target INTERFACE)
    target_link_libraries(viennacl_target INTERFACE amgcl)
    target_include_directories(viennacl_target INTERFACE ${VIENNACL_INCLUDE})
    target_compile_definitions(viennacl_target INTERFACE SOLVER_BACKEND_VIENNACL)

    find_package(OpenCL)
    if (OpenCL_FOUND)
        target_include_directories(viennacl_target INTERFACE ${OpenCL_INCLUDE_DIRS})
        target_link_libraries(viennacl_target INTERFACE ${OpenCL_LIBRARY})
        target_compile_definitions(viennacl_target INTERFACE VIENNACL_WITH_OPENCL)
        target_compile_options(viennacl_target INTERFACE
            $<$<CXX_COMPILER_ID:GNU>:-Wno-ignored-attributes>
            $<$<CXX_COMPILER_ID:GNU>:-Wno-deprecated-declarations>
            $<$<CXX_COMPILER_ID:GNU>:-Wno-deprecated-copy>
            $<$<CXX_COMPILER_ID:Clang>:-Wno-ignored-attributes>
            $<$<CXX_COMPILER_ID:Clang>:-Wno-deprecated-declarations>
            )
    else()
        target_compile_definitions(viennacl_target INTERFACE VIENNACL_WITH_OPENMP)
    endif()
endif()

#----------------------------------------------------------------------------
# Find CUDA
#----------------------------------------------------------------------------
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    find_package(CUDA)
    if (CUDA_FOUND)
        set(CUDA_TARGET_ARCH "Kepler Maxwell Pascal" CACHE STRING "Target architecture(s) for CUDA")
        cuda_select_nvcc_arch_flags(CUDA_ARCH_FLAGS ${CUDA_TARGET_ARCH})

        if (OPENMP_FOUND)
            list(APPEND CUDA_NVCC_FLAGS -Xcompiler ${OpenMP_CXX_FLAGS})
        endif()

        if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
	    list(APPEND CUDA_NVCC_FLAGS
                ${CUDA_ARCH_FLAGS} -Wno-deprecated-gpu-targets)

            list(APPEND CUDA_NVCC_FLAGS -Xcompiler -fPIC -Xcompiler -Wno-vla)
        endif()

        add_library(cuda_target INTERFACE)
        target_link_libraries(cuda_target INTERFACE ${CUDA_cusparse_LIBRARY})
    endif()
endif()

#----------------------------------------------------------------------------
# Find MPI
#----------------------------------------------------------------------------
find_package(MPI 3.0)
if (MPI_CXX_FOUND)
    # Need this to comply with CMP004 policy:
    string(STRIP "${MPI_CXX_LINK_FLAGS}" MPI_CXX_LINK_FLAGS)
    string(STRIP "${MPI_CXX_LIBRARIES}" MPI_CXX_LIBRARIES)

    add_library(mpi_target INTERFACE)
    target_link_libraries(mpi_target INTERFACE amgcl ${MPI_CXX_LIBRARIES})
    target_include_directories(mpi_target INTERFACE ${MPI_CXX_INCLUDE_PATH})
    target_compile_options(mpi_target INTERFACE
        $<$<CXX_COMPILER_ID:GNU>:-Wno-long-long>
        $<$<CXX_COMPILER_ID:GNU>:-Wno-literal-suffix>
        $<$<CXX_COMPILER_ID:Clang>:-Wno-long-long>
        )
endif()

#----------------------------------------------------------------------------
# Find Pastix
#----------------------------------------------------------------------------
find_package(Metis  QUIET)
find_package(Scotch QUIET)
find_package(Pastix QUIET)
find_package(BLAS   QUIET)
find_library(PTHREAD_LIBRARY pthread)
find_library(BZ2_LIBRARY bz2)
find_library(HWLOC_LIBRARY hwloc)

if (Scotch_FOUND)
    add_library(scotch_target INTERFACE)
    target_include_directories(scotch_target INTERFACE ${Scotch_INCLUDES})
    target_link_libraries(scotch_target INTERFACE ${Scotch_LIBRARIES})
    target_compile_definitions(scotch_target INTERFACE AMGCL_HAVE_SCOTCH)
endif()

if (Pastix_INCLUDES AND Scotch_FOUND AND BLAS_FOUND AND PTHREAD_LIBRARY AND BZ2_LIBRARY)
    add_library(pastix_target INTERFACE)
    target_include_directories(pastix_target INTERFACE
        ${Pastix_INCLUDES}
        ${Scotch_INCLUDES}
        )
    target_link_libraries(pastix_target INTERFACE
        ${Pastix_LIBRARIES}
        ${Scotch_LIBRARIES}
        ${BLAS_LIBRARIES}
        ${PTHREAD_LIBRARY}
        ${BZ2_LIBRARY}
        ${HWLOC_LIBRARY}
        )
    target_compile_definitions(pastix_target INTERFACE AMGCL_HAVE_PASTIX)
endif()

if (AMGCL_MASTER_PROJECT)
    option(AMGCL_BUILD_TESTS    OFF)
    option(AMGCL_BUILD_EXAMPLES OFF)
    option(AMGCL_DISABLE_RARE_COMPONENTS OFF)

    if(AMGCL_DISABLE_RARE_COMPONENTS)
        add_definitions(
            -DAMGCL_RUNTIME_DISABLE_MULTICOLOR_GS
            -DAMGCL_RUNTIME_DISABLE_SPAI1
            -DAMGCL_RUNTIME_DISABLE_CHEBYSHEV
            )
    endif()

    add_subdirectory(docs)

    if (AMGCL_BUILD_TESTS)
        enable_testing()
        add_subdirectory(tests)
    endif()

    if (AMGCL_BUILD_EXAMPLES)
        add_subdirectory(lib)
        add_subdirectory(examples)
        add_subdirectory(tutorial)

        #----------------------------------------------------------------------------
        # Build Fortran example
        #----------------------------------------------------------------------------
        option(AMGCL_HAVE_FORTRAN "Build Fortran example" OFF)
        if (AMGCL_HAVE_FORTRAN)
            add_subdirectory(fortran)
        endif()

        #----------------------------------------------------------------------------
        # Build Python example
        #----------------------------------------------------------------------------
        option(AMGCL_HAVE_PYTHON "Build Python example" OFF)
        if (AMGCL_HAVE_PYTHON)
            add_subdirectory(pyamgcl)
        endif()
    endif()
    
    install(DIRECTORY amgcl DESTINATION include)

    install(TARGETS amgcl EXPORT amgclTargets)

    if(TARGET eigen)
        install(TARGETS eigen EXPORT amgclTargets)
    endif()

    if(TARGET blaze)
        install(TARGETS blaze EXPORT amgclTargets)
    endif()

    if(TARGET viennacl)
        install(TARGETS viennacl EXPORT amgclTargets)
    endif()

    if(TARGET mpi)
        install(TARGETS mpi EXPORT amgclTargets)
    endif()

    configure_file(
        "${CMAKE_CURRENT_SOURCE_DIR}/cmake/amgcl-config.cmake.in"
        "${CMAKE_CURRENT_BINARY_DIR}/cmake/amgcl-config.cmake"
        COPYONLY
        )

    export(EXPORT amgclTargets
        FILE "${CMAKE_CURRENT_BINARY_DIR}/cmake/amgcl-targets.cmake"
        NAMESPACE amgcl::
        )

    export(PACKAGE amgcl)

    install(EXPORT amgclTargets
        FILE amgcl-targets.cmake
        NAMESPACE amgcl::
        DESTINATION share/amgcl/cmake
        )

    install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/cmake/amgcl-config.cmake
        DESTINATION share/amgcl/cmake
        )
endif()

=== docs/requirements.txt ===
docutils<0.18
matplotlib

=== examples/mpi/CMakeLists.txt ===
if (TARGET mpi_target)
    add_library(amgcl_mpi_example INTERFACE)
    target_link_libraries(amgcl_mpi_example INTERFACE
        amgcl mpi_target ${Boost_PROGRAM_OPTIONS_LIBRARY})
    target_compile_definitions(amgcl_mpi_example INTERFACE "AMGCL_BLOCK_SIZES=${AMGCL_BLOCK_SIZES_SEQ}")

    if (TARGET eigen_target)
        target_link_libraries(amgcl_mpi_example INTERFACE eigen_target)
    endif()

    if (TARGET pastix_target)
        target_link_libraries(amgcl_mpi_example INTERFACE pastix_target)
    endif()

    if (TARGET scotch_target)
        target_link_libraries(amgcl_mpi_example INTERFACE scotch_target)
    endif()

    if (TARGET Metis::metis)
        target_link_libraries(amgcl_mpi_example INTERFACE Metis::metis)
    endif()

    function(add_mpi_example example sources)
        add_executable(${example} ${sources})
        target_link_libraries(${example} amgcl_mpi_example)
    endfunction()

    add_mpi_example(check_direct        check_direct.cpp)
    add_mpi_example(runtime_sdd         runtime_sdd.cpp)
    add_mpi_example(runtime_sdd_3d      runtime_sdd_3d.cpp)
    add_mpi_example(runtime_bp          runtime_bp.cpp)
    add_mpi_example(schur_pc_mpi        schur_pc_mpi.cpp)
    add_mpi_example(solve_mm_mpi        solve_mm_mpi.cpp)
    add_mpi_example(call_mpi_lib        call_mpi_lib.cpp)
    add_mpi_example(test_transpose      test_transpose.cpp)
    add_mpi_example(test_spmm           test_spmm.cpp)
    add_mpi_example(spmm_scaling        spmm_scaling.cpp)
    add_mpi_example(mpi_solver          mpi_solver.cpp)
    add_mpi_example(mpi_complex         mpi_complex.cpp)
    add_mpi_example(cpr_mpi             cpr_mpi.cpp)

    if (TARGET Metis::metis)
        add_executable(partition partition.cpp)
        target_link_libraries(partition
            amgcl
            Metis::metis
            ${Boost_PROGRAM_OPTIONS_LIBRARY}
            )
    endif()

    target_link_libraries(call_mpi_lib libamgcl_mpi)

    if (TARGET cuda_target)
        foreach(example runtime_sdd runtime_sdd_3d schur_pc_mpi mpi_solver)
            configure_file(
                ${CMAKE_CURRENT_SOURCE_DIR}/${example}.cpp
                ${CMAKE_CURRENT_BINARY_DIR}/${example}.cu
                COPYONLY
                )
            cuda_add_executable(${example}_cuda
                ${CMAKE_CURRENT_BINARY_DIR}/${example}.cu
                OPTIONS -DSOLVER_BACKEND_CUDA)
            target_include_directories(${example}_cuda PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
            target_link_libraries(${example}_cuda amgcl_example cuda_target mpi_target)
        endforeach()
    endif()

    if (VexCL_FOUND)
        foreach(example runtime_sdd runtime_sdd_3d schur_pc_mpi mpi_solver)
            vexcl_add_executables(${example}_vexcl ${example}.cpp)
            target_compile_definitions(${example}_vexcl INTERFACE SOLVER_BACKEND_VEXCL)
            target_link_libraries(${example}_vexcl INTERFACE amgcl_mpi_example)
        endforeach()
    endif()

    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/plot_result
        ${CMAKE_CURRENT_BINARY_DIR}/plot_result
        COPYONLY
        )
endif()

=== tutorial/1.poisson3Db/CMakeLists.txt ===
add_executable(poisson3Db poisson3Db.cpp)
target_link_libraries(poisson3Db amgcl)

add_executable(poisson3Db_mixed poisson3Db.cpp)
target_link_libraries(poisson3Db_mixed amgcl)
target_compile_definitions(poisson3Db_mixed PRIVATE MIXED_PRECISION)

if (TARGET cuda_target)
    cuda_add_executable(poisson3Db_cuda poisson3Db_cuda.cu)
    target_link_libraries(poisson3Db_cuda amgcl cuda_target)
endif()

if(TARGET mpi_target)
    add_executable(poisson3Db_mpi poisson3Db_mpi.cpp)
    target_link_libraries(poisson3Db_mpi amgcl mpi_target)

    if (TARGET scotch_target)
        target_link_libraries(poisson3Db_mpi scotch_target)
    endif()

    if (TARGET Metis::metis)
        target_link_libraries(poisson3Db_mpi Metis::metis)
    endif()

    if (VexCL_FOUND)
        vexcl_add_executables(poisson3Db_mpi_vexcl poisson3Db_mpi_vexcl.cpp)
        target_link_libraries(poisson3Db_mpi_vexcl INTERFACE amgcl mpi_target)

        if (TARGET scotch_target)
            target_link_libraries(poisson3Db_mpi_vexcl INTERFACE scotch_target)
        endif()

        if (TARGET Metis::metis)
            target_link_libraries(poisson3Db_mpi_vexcl INTERFACE Metis::metis)
        endif()
    endif()
endif()

=== tutorial/3.CoupCons3D/CMakeLists.txt ===
add_executable(coupcons3d coupcons3d.cpp)
target_link_libraries(coupcons3d amgcl)

add_executable(coupcons3d_spc coupcons3d_spc.cpp)
target_link_libraries(coupcons3d_spc amgcl)

if (VexCL_FOUND)
    vexcl_add_executables(coupcons3d_vexcl coupcons3d_vexcl.cpp)
    target_link_libraries(coupcons3d_vexcl INTERFACE amgcl)
endif()

=== tutorial/4.Stokes/CMakeLists.txt ===
add_executable(stokes_ucube stokes_ucube.cpp)
target_link_libraries(stokes_ucube amgcl)

if (VexCL_FOUND)
    vexcl_add_executables(stokes_ucube_vexcl stokes_ucube_vexcl.cpp)
    target_link_libraries(stokes_ucube_vexcl INTERFACE amgcl)
endif()

=== debian/changelog ===
amgcl (1.4.3-5build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 19 Jan 2024 18:54:47 +0000

amgcl (1.4.3-5) unstable; urgency=medium

  * Fixed build on 32-bit platforms. Again. (Closes: #1020834)

 -- Dima Kogan <dkogan@debian.org>  Mon, 02 Jan 2023 22:28:19 -0800

amgcl (1.4.3-4) unstable; urgency=medium

  * Fixed build on 32-bit platforms (Closes: #1020834)

 -- Dima Kogan <dkogan@debian.org>  Mon, 19 Dec 2022 20:37:12 -0800

amgcl (1.4.3-3) unstable; urgency=medium

  * Build-Depends: python3-dev, not python3-all-dev (Closes: #1024313)

 -- Dima Kogan <dkogan@debian.org>  Sat, 19 Nov 2022 14:47:54 -0800

amgcl (1.4.3-2) unstable; urgency=medium

  * More explicit copyright notes
  * This project is in contrib

 -- Dima Kogan <dkogan@debian.org>  Fri, 12 Aug 2022 20:37:29 -0700

amgcl (1.4.3-1) unstable; urgency=medium

  * Initial upload into Debian (Closes: #1015820)

 -- Dima Kogan <dkogan@debian.org>  Thu, 21 Jul 2022 13:29:17 -0700

=== debian/watch ===
version=4
https://github.com/ddemidov/amgcl/tags .*/?(\d\S+)\.tar\.gz

## amgcl 1.4.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,7 +28,7 @@
     set(Boost_USE_STATIC_LIBS ON)
 endif ()
 
-find_package(Boost REQUIRED COMPONENTS
+find_package(Boost COMPONENTS
     program_options
     serialization
     unit_test_framework
@@ -48,9 +48,13 @@
     cxx_static_assert
 )
 
-target_include_directories(amgcl SYSTEM INTERFACE
-    ${Boost_INCLUDE_DIRS}
-    )
+if (Boost_FOUND)
+    target_include_directories(amgcl SYSTEM INTERFACE
+        ${Boost_INCLUDE_DIRS}
+        )
+else()
+    target_compile_definitions(amgcl INTERFACE AMGCL_NO_BOOST)
+endif()
 
 target_include_directories(amgcl INTERFACE
     $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
@@ -117,7 +121,9 @@
 #----------------------------------------------------------------------------
 # Find VexCL
 #----------------------------------------------------------------------------
-find_package(VexCL QUIET)
+if (Boost_FOUND)
+    find_package(VexCL QUIET)
+endif()
 
 #----------------------------------------------------------------------------
 # Find ViennaCL
@@ -226,8 +232,11 @@
 endif()
 
 if (AMGCL_MASTER_PROJECT)
-    option(AMGCL_BUILD_TESTS    OFF)
-    option(AMGCL_BUILD_EXAMPLES OFF)
+    if (Boost_FOUND)
+        option(AMGCL_BUILD_TESTS    OFF)
+        option(AMGCL_BUILD_EXAMPLES OFF)
+    endif()
+
     option(AMGCL_DISABLE_RARE_COMPONENTS OFF)
 
     if(AMGCL_DISABLE_RARE_COMPONENTS)

=== docs/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)
project(doc)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/conf.py
    ${CMAKE_CURRENT_BINARY_DIR}/conf.py
    COPYONLY
    )

add_custom_target(doc
    COMMAND sphinx-build -b html -c ${CMAKE_CURRENT_SOURCE_DIR} . ${CMAKE_CURRENT_BINARY_DIR}/html
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Generate HTML documentation"
    )

=== examples/CMakeLists.txt ===
add_library(amgcl_example INTERFACE)
target_include_directories(amgcl_example INTERFACE
    ${CMAKE_CURRENT_SOURCE_DIR}/../tests
    ${Boost_INCLUDE_DIRS}
    )

target_link_libraries(amgcl_example INTERFACE
    amgcl
    ${Boost_PROGRAM_OPTIONS_LIBRARY}
    )

set(AMGCL_BLOCK_SIZES "3;4" CACHE STRING "Block sizes for block solvers in examples")
set(AMGCL_BLOCK_SIZES_SEQ "")
foreach(B ${AMGCL_BLOCK_SIZES})
    set(AMGCL_BLOCK_SIZES_SEQ "${AMGCL_BLOCK_SIZES_SEQ}(${B})")
endforeach()
target_compile_definitions(amgcl_example INTERFACE "AMGCL_BLOCK_SIZES=${AMGCL_BLOCK_SIZES_SEQ}")

function(add_amgcl_example EXAMPLE SOURCES)
    add_executable(${EXAMPLE} ${SOURCES})
    target_link_libraries(${EXAMPLE} amgcl_example)
endfunction()

add_amgcl_example(mm2bin mm2bin.cpp)
add_amgcl_example(bin2mm bin2mm.cpp)
add_amgcl_example(solver solver.cpp)
add_amgcl_example(solver_complex solver_complex.cpp)
add_amgcl_example(crs_builder crs_builder.cpp)
add_amgcl_example(block_crs block_crs.cpp)
add_amgcl_example(schur_pressure_correction schur_pressure_correction.cpp)
add_amgcl_example(cpr cpr.cpp)
add_amgcl_example(cpr_drs cpr_drs.cpp)
add_amgcl_example(custom_adapter custom_adapter.cpp)
add_amgcl_example(mixed_precision mixed_precision.cpp)
add_amgcl_example(schurpc_mixed schurpc_mixed.cpp)
add_amgcl_example(deflated_solver deflated_solver.cpp)
add_amgcl_example(ns_search ns_search.cpp)

add_amgcl_example(ublas ublas.cpp)
target_link_libraries(ublas ${Boost_SERIALIZATION_LIBRARY})

if (TARGET eigen_target)
    add_amgcl_example(solver_eigen solver.cpp)
    target_link_libraries(solver_eigen eigen_target)
    target_compile_definitions(solver_eigen PRIVATE SOLVER_BACKEND_EIGEN)

    add_amgcl_example(schurpc_mixed_eigen schurpc_mixed.cpp)
    target_link_libraries(schurpc_mixed_eigen eigen_target)
    target_compile_definitions(schurpc_mixed_eigen PRIVATE BLOCK_TYPE_EIGEN)
endif()

if (TARGET blaze_target)
    add_amgcl_example(solver_blaze solver.cpp)
    target_link_libraries(solver_blaze blaze_target)
    target_compile_definitions(solver_blaze PRIVATE SOLVER_BACKEND_BLAZE)
endif()

add_amgcl_example(call_lib call_lib.cpp)
target_link_libraries(call_lib libamgcl)

#----------------------------------------------------------------------------
# The HPX backend example
#----------------------------------------------------------------------------
find_package(HPX QUIET)
if (HPX_FOUND)
    add_hpx_executable(solver_hpx SOURCES solver_hpx.cpp)
    hpx_setup_target(solver_hpx_exe DEPENDENCIES amgcl_example)
endif()

if (VexCL_FOUND)
    vexcl_add_executables(vexcl vexcl.cpp)
    target_link_libraries(vexcl INTERFACE amgcl_example)

    vexcl_add_executables(solver_vexcl solver.cpp)
    target_link_libraries(solver_vexcl INTERFACE amgcl_example)
    target_compile_definitions(solver_vexcl INTERFACE SOLVER_BACKEND_VEXCL)

    vexcl_add_executables(schur_pressure_correction_vexcl schur_pressure_correction.cpp)
    target_link_libraries(schur_pressure_correction_vexcl INTERFACE amgcl_example)
    target_compile_definitions(schur_pressure_correction_vexcl INTERFACE SOLVER_BACKEND_VEXCL)

    vexcl_add_executables(cpr_drs_vexcl cpr_drs.cpp)
    target_link_libraries(cpr_drs_vexcl INTERFACE amgcl_example)
    target_compile_definitions(cpr_drs_vexcl INTERFACE SOLVER_BACKEND_VEXCL)

    vexcl_add_executables(mixed_precision_vexcl mixed_precision.cpp)
    target_link_libraries(mixed_precision_vexcl INTERFACE amgcl_example)
    target_compile_definitions(mixed_precision_vexcl INTERFACE SOLVER_BACKEND_VEXCL)

    vexcl_add_executables(schurpc_mixed_vexcl schurpc_mixed.cpp)
    target_link_libraries(schurpc_mixed_vexcl INTERFACE amgcl_example)
    target_compile_definitions(schurpc_mixed_vexcl INTERFACE SOLVER_BACKEND_VEXCL)
endif()

if (TARGET viennacl_target)
    add_amgcl_example(solver_viennacl solver.cpp)
    target_link_libraries(solver_viennacl viennacl_target)
    target_compile_definitions(solver_viennacl PRIVATE SOLVER_BACKEND_VIENNACL)

    add_amgcl_example(schur_pressure_correction_viennacl schur_pressure_correction.cpp)
    target_link_libraries(schur_pressure_correction_viennacl viennacl_target)
    target_compile_definitions(schur_pressure_correction_viennacl PRIVATE SOLVER_BACKEND_VIENNACL)

    add_amgcl_example(cpr_drs_viennacl cpr_drs.cpp)
    target_link_libraries(cpr_drs_viennacl viennacl_target)
    target_compile_definitions(cpr_drs_viennacl PRIVATE SOLVER_BACKEND_VIENNACL)
endif()

if (TARGET cuda_target)
    function(add_cuda_example example)
        configure_file(
            ${CMAKE_CURRENT_SOURCE_DIR}/${example}.cpp
            ${CMAKE_CURRENT_BINARY_DIR}/${example}.cu
            COPYONLY
            )

        cuda_add_executable(${example}_cuda ${CMAKE_CURRENT_BINARY_DIR}/${example}.cu
            OPTIONS -DSOLVER_BACKEND_CUDA)
        target_link_libraries(${example}_cuda amgcl_example cuda_target)
    endfunction()

    add_cuda_example(solver)
    add_cuda_example(schur_pressure_correction)
    add_cuda_example(cpr_drs)
endif()

add_subdirectory(mpi)

=== fortran/CMakeLists.txt ===
enable_language(Fortran)

add_executable(poisson poisson.f90 amgcl.f90)
target_link_libraries(poisson libamgcl)

=== tutorial/CMakeLists.txt ===
add_subdirectory(1.poisson3Db)
add_subdirectory(2.Serena)
add_subdirectory(3.CoupCons3D)
add_subdirectory(4.Stokes)
add_subdirectory(5.Nullspace)

=== tutorial/2.Serena/CMakeLists.txt ===
add_executable(serena serena.cpp)
target_link_libraries(serena amgcl)

if (VexCL_FOUND)
    vexcl_add_executables(serena_vexcl serena_vexcl.cpp)
    target_link_libraries(serena_vexcl INTERFACE amgcl)
endif()

if (TARGET mpi_target)
    add_executable(serena_mpi serena_mpi.cpp)
    target_link_libraries(serena_mpi amgcl mpi_target)

    if (TARGET scotch_target)
        target_link_libraries(serena_mpi scotch_target)
    endif()

    if (TARGET Metis::metis)
        target_link_libraries(serena_mpi Metis::metis)
    endif()

    if (VexCL_FOUND)
        vexcl_add_executables(serena_mpi_vexcl serena_mpi_vexcl.cpp)
        target_link_libraries(serena_mpi_vexcl INTERFACE amgcl mpi_target)

        if (TARGET scotch_target)
            target_link_libraries(serena_mpi_vexcl INTERFACE scotch_target)
        endif()

        if (TARGET Metis::metis)
            target_link_libraries(serena_mpi_vexcl INTERFACE Metis::metis)
        endif()
    endif()
endif()

=== debian/changelog ===
amgcl (1.4.4-1) unstable; urgency=medium

  * New upstream release
  * Fixed build with scipy 1.14 (Closes: #1090190)

 -- Dima Kogan <dkogan@debian.org>  Mon, 13 Jan 2025 21:42:55 -0800

amgcl (1.4.3-7) unstable; urgency=medium

  * Added Build-Depends:python3-setuptools (Closes: #1080534)

 -- Dima Kogan <dkogan@debian.org>  Fri, 06 Sep 2024 13:18:08 -0700

amgcl (1.4.3-6) unstable; urgency=medium

  * Rebuild for python 3.12

 -- Dima Kogan <dkogan@debian.org>  Tue, 25 Jun 2024 20:54:38 -0700

=== debian/control ===
Source: amgcl
Section: contrib/libdevel
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libboost-test-dev,
               libboost-serialization-dev,
               libboost-program-options-dev,
               libeigen3-dev,
               libviennacl-dev,
               libopenmpi-dev,
               libmetis-dev,
               libparmetis-dev,
               libblas-dev,
               libscotch-dev,
               libbz2-dev,
               libhwloc-dev,
               gfortran,
               dh-python,
# for "make install" to work. See
#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1080534
               python3-setuptools,
               pybind11-dev,
               python3-dev:any,
               libpython3-dev,
# These are for the tests only
               python3-numpy <!nocheck>,
               python3-scipy <!nocheck>
Standards-Version: 4.6.0
Homepage: https://github.com/ddemidov/amgcl
Vcs-Git: https://salsa.debian.org/science-team/amgcl.git
Vcs-Browser: https://salsa.debian.org/science-team/amgcl

Package: libamgcl-dev
Architecture: all
Depends: ${misc:Depends},
Description: Solves large sparse linear systems with algebraic multigrid method
 AMG is one of the most effective iterative methods for solution of equation
 systems arising, for example, from discretizing PDEs on unstructured grids. The
 method can be used as a black-box solver for various computational problems,
 since it does not require any information about the underlying geometry. AMG is
 often used not as a standalone solver but as a preconditioner within an
 iterative solver (e.g. Conjugate Gradients, BiCGStab, or GMRES).
 .
 AMGCL builds the AMG hierarchy on a CPU and then transfers it to one of the
 provided backends. This allows for transparent acceleration of the solution
 phase with help of OpenCL, CUDA, or OpenMP technologies. Users may provide
 their own backends which enables tight integration between AMGCL and the user
 code.
 .
 AMG is a header-only C++ library, with the headers provided by this package.

Package: python3-amgcl
Section: contrib/python
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
         ${python3:Depends}
Provides: ${python3:Provides}
Description: Solves large sparse linear systems with algebraic multigrid method
 AMG is one of the most effective iterative methods for solution of equation
 systems arising, for example, from discretizing PDEs on unstructured grids. The
 method can be used as a black-box solver for various computational problems,
 since it does not require any information about the underlying geometry. AMG is
 often used not as a standalone solver but as a preconditioner within an
 iterative solver (e.g. Conjugate Gradients, BiCGStab, or GMRES).
 .
 AMGCL builds the AMG hierarchy on a CPU and then transfers it to one of the
 provided backends. This allows for transparent acceleration of the solution
 phase with help of OpenCL, CUDA, or OpenMP technologies. Users may provide
 their own backends which enables tight integration between AMGCL and the user
 code.
 .
 This package provides the Python interface

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DAMGCL_BUILD_TESTS=ON \
		-DAMGCL_BUILD_EXAMPLES=ON \
		-DAMGCL_DISABLE_RARE_COMPONENTS=OFF \
		-DAMGCL_HAVE_PYTHON=ON \
		-DAMGCL_HAVE_FORTRAN=ON

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp
	mkdir -p debian/tmp/usr/lib/python3/dist-packages/pyamgcl
	cp obj-*/pyamgcl/pyamgcl_ext.cpython-*.so debian/tmp/usr/lib/python3/dist-packages/pyamgcl
	cp pyamgcl/__init__.py                    debian/tmp/usr/lib/python3/dist-packages/pyamgcl

override_dh_installdocs:
	dh_installdocs -X.git\*

=== debian/watch ===
version=4
https://github.com/ddemidov/amgcl/tags .*/(\d\S+)\.tar\.gz
